#import <Cocoa/Cocoa.h>

@class RParsedExpression;
@class REnvironment;


// Contains the basic information for an R value. Presently much less functional than
// Simon's version in R.app, but I imagine that will change as other people get in here
// and as I need them for more things.
@interface RValue : NSObject {
	void* rPtr;
}
+ (NSLock*)gil;

+ (RValue*)valueWithPointer:(void*)ptr;
- (id)initWithPointer:(void*)ptr;


+ (RValue*)valueWithString:(NSString*)aStr;
+ (RValue*)valueWithInteger:(NSInteger)anInt;


- (RValue*)evaluateInEnvironment:(REnvironment*)env block:(BOOL)shouldBlock;
- (RValue*)evaluate;

- (RParsedExpression*)parseWithError:(NSError**)error;

- (void*)pointer;

- (NSString*)stringValue;
- (NSArray*)arrayValue;

- (NSInteger)length;

- (BOOL)isStringType;

@end
